%define build_ocamlopt	1
%ifarch ppc64 %mips %arm
%define build_ocamlopt	0
%endif
%define build_labltk	1
%define name	ocaml
%define major	3.11
%define minor	0
%define version	3.11.1
%define release	%mkrel 3

# we don't want the auto require to add require on the currently installed ocaml
%define _requires_exceptions ocaml

Name:		%{name}
Version:	%{version}
Release:	%{release}
Summary:	The Objective Caml compiler and programming environment
URL:		http://caml.inria.fr
License:	QPL with exceptions and LGPLv2 with exceptions
Group:		Development/Other
Source0:	ftp://ftp.inria.fr/INRIA/cristal/caml-light/ocaml-%{major}/%{name}-%{version}.tar.bz2
Source1:	ftp://ftp.inria.fr/INRIA/cristal/caml-light/ocaml-%{major}/%{name}-%{major}-refman.html.tar.gz
Source4:	%{name}.menu
Source5:	findlib-1.2.4-ocaml-3.11.1-meta-files.tar.bz2
Patch3:		ocaml-3.11.0-ocamltags-no-site-start.patch
Patch6:		ocaml-3.04-do-not-add-rpath-X11R6_lib-when-using-option-L.patch
Patch7:		ocaml-3.11.0-no-opt-for-debug-and-profile.patch
Patch8:		ocaml-3.04-larger-buffer-for-uncaught-exception-messages.patch
Patch9:		ocaml-3.11.0-handle-tk-8.6.patch
Patch16:	ocaml-3.09.2-lib64.patch
Patch17:	ocaml-3.11.0-db4.patch
Patch18:	ocaml-3.09.3-compile-emacs-files-in-build-dir.patch
Patch19:	ocaml-3.12.0-fix-ocamlopt-w.r.t.-binutils-2.21.patch
BuildRequires:	libx11-devel
BuildRequires:	ncurses-devel
BuildRequires:	tcl
BuildRequires:	tcl-devel
BuildRequires:	tk
BuildRequires:	tk-devel
BuildRequires:	emacs-bin
BuildRequires:	libdb4.8-devel
BuildRoot:	%{_tmppath}/%{name}-%{version}
Obsoletes:	ocaml-emacs
Provides:	ocaml-emacs

%package	doc
Summary:	Documentation for OCaml
Group:		Books/Computer books
Requires:	%{name} = %{version}

%package -n	camlp4
Summary:	Preprocessor for OCaml
Group:		Development/Other
Requires:	%{name} = %{version}

%package labltk
Summary:	Tk toolkit binding for OCaml
Group:		Development/Other
Requires:	%{name} = %{version}
Requires:	tk-devel
Obsoletes:  ocamltk

%package sources
Summary:	OCaml sources
Group:		Development/Other
AutoReqProv: No

%description
Objective Caml is a high-level, strongly-typed, functional and object-oriented
programming language from the ML family of languages.

This package comprises two batch compilers (a fast bytecode compiler and an
optimizing native-code compiler), an interactive toplevel system, Lex&Yacc
tools, a replay debugger, and a comprehensive library.

%description	doc
Documentation for OCaml

%description -n	camlp4
Preprocessor for OCaml

%description labltk
Tk toolkit binding for OCaml

%description sources
OCaml sources

%prep
%setup -q -T -b 0
%setup -q -T -D -a 1
%setup -q -T -D -a 5
%patch3 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1 -b .tk
%patch16 -p1 -b .lib64
%patch17 -p1 -b .db4
%patch18 -p1 -b .emacs
%patch19 -p1 -b .binutils-2.21

rm -rf `find -name .cvsignore`

%build
%ifarch alpha
echo %{optflags} | grep -q mieee || { echo "on alpha you need -mieee to compile ocaml"; exit 1; }
%endif

./configure -bindir %{_bindir} -libdir %{_libdir}/ocaml -mandir %{_mandir}/man1
make world
%if %{build_ocamlopt}
make opt opt.opt
%endif

%install
rm -rf %{buildroot}
make install BINDIR=%{buildroot}%{_bindir} LIBDIR=%{buildroot}%{_libdir}/ocaml MANDIR=%{buildroot}%{_mandir}

cd emacs; make install install-ocamltags BINDIR=%{buildroot}%{_bindir} EMACSDIR=%{buildroot}%{_datadir}/emacs/site-lisp; cd -

# fix
perl -pi -e "s|%{buildroot}||" %{buildroot}%{_libdir}/ocaml/ld.conf

%if %{build_ocamlopt}
for i in %{buildroot}%{_bindir}/*.opt ; do
  [[ $i == %{buildroot}%{_bindir}/camlp4* ]] && continue
  ln -sf `basename $i` ${i%.opt}
done
%endif


install -d %{buildroot}%{_sysconfdir}/emacs/site-start.d
cat <<EOF >%{buildroot}%{_sysconfdir}/emacs/site-start.d/%{name}.el
(require 'caml-font)
(autoload 'caml-mode "caml" "Caml editing mode" t)
(add-to-list 'auto-mode-alist '("\\\\.mli?$" . caml-mode))
EOF

# don't package mano man pages since we have the html files
rm -rf %{buildroot}%{_mandir}/mano

# install findlib META files
cp -pr site-lib-src/* %{buildroot}%{_libdir}/ocaml/

rm -f %{name}.list
n="labltk|camlp4|ocamlbrowser|tkanim"
(cd %{buildroot} ; find usr/bin ! -type d -printf "/%%p\n" | egrep -v $n) >> %{name}.list
(cd %{buildroot} ; find usr/%{_lib}/ocaml ! -type d -printf "/%%p\n" | egrep -v $n) >> %{name}.list
(cd %{buildroot} ; find usr/%{_lib}/ocaml   -type d -printf "%%%%dir /%%p\n" | egrep -v $n) >> %{name}.list

# install sources
install -d -m 755 %{buildroot}%{_prefix}/src
tar xvjf %{SOURCE0} -C %{buildroot}%{_prefix}/src
mv %{buildroot}%{_prefix}/src/%{name}-%{version} %{buildroot}%{_prefix}/src/%{name}

%clean
rm -rf %{buildroot}

%files -f %{name}.list
%defattr(-,root,root)
%doc Changes LICENSE README
%{_mandir}/man1/*
#%{_menudir}/*
%{_datadir}/emacs/site-lisp/*
%config(noreplace) %{_sysconfdir}/emacs/site-start.d/*

%files doc
%defattr(-,root,root)
%doc htmlman/* 
%if %build_ocamlopt
%{_mandir}/man3/*
%endif

%if %{build_labltk}
%files labltk
%defattr(-,root,root)
%doc otherlibs/labltk/README otherlibs/labltk/example*
%{_bindir}/*labltk*
%{_bindir}/ocamlbrowser
%{_libdir}/ocaml/*labltk*
%{_libdir}/ocaml/stublibs/dlllabltk.so
%{_libdir}/ocaml/stublibs/dlltkanim.so
%endif

%files -n camlp4
%defattr(-,root,root)
%{_bindir}/*camlp4*
%{_libdir}/ocaml/camlp4

%files sources
%defattr(-,root,root)
%{_prefix}/src/%{name}


%changelog
* Fri Jun 24 2011 Texstar <texstar at gmail.com> 3.11.1-3pclos2011
- rebuild for new gcc glibc

* Sat Dec 26 2009 Texstar <texstar at gmail.com> 3.11.1-2pclos2010
- rebuild for tcl and tk

* Thu Dec 24 2009 Texstar <texstar at gmail.com> 3.11.1-1pclos2010
- gcc update
- 3.11.1

